import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.*;
/**
 * Die Tomatenpflanzen mssen durch Sen von Tomaten gepflanzt 
 * werden. Dann muss man sie gieen, damit sie wachsen. Sie haben 
 * also einen Wasserbedarf (Durst). Erntet man reife Tomaten, wachsen
 * grne Tomaten nach.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Tomate extends Gegenstand
{
    private int durst;
    public Tomate() {
        super("Tomate",false, true,0);
        durst = 0;
    }


    protected void zeichneImage() {
        bildnummer = Math.min(wert/25,4);
        super.zeichneImage();
        zeichneEnergie();
    }

    public void wachse() {
        Random r = new Random();
        if(wert < 100 && durst > 0) {
            wert += 1;
            durst-= r.nextInt(5)+1;
            if( durst < 0) durst = 0;
        }
        zeichneImage();
        Greenfoot.delay(0);
    }
    
    public void addedToWorld(World w) {
        super.addedToWorld(w);
        ((Bauernhofprojekt) w).addAktion(()->wachse());
    }    
    
    public void giesse() {
        durst = 100;
        zeichneImage();
    }
    
    public int getDurst() {
        return durst;
    }
    
   
    public void setzeBild(int nr)  {
        if(nr>= 0 && nr < 5) {
            wert = nr*25;
        } else {
           wert = 0; 
        }
        zeichneImage();
    }
    
    public void ernte() {
        if(wert == 100) {
            wert -= 50;
            zeichneImage();
        } 
    }
 
    /**
     * Zeichne den Wasserbedarfsbalken
     */
    protected void zeichneEnergie()
    {
        final int breite = 30;
        final int hoehe = 3;
        final int x=(getImage().getWidth()-breite)/2;
        final int y=0;
        
        
        this.getImage().setColor(Color.BLUE);
        this.getImage().fillRect(x, y+hoehe, breite, hoehe);
        int breiteNeu = breite-(int)(Math.floor(breite*(durst/100.0)));
        this.getImage().setColor(Color.RED);
        this.getImage().fillRect(x+breite-breiteNeu, y+hoehe, breiteNeu, hoehe);
        this.getImage().setColor(Color.BLACK);
        this.getImage().drawRect(x, y+hoehe, breite, hoehe);
        this.getImage().drawRect(x, y+hoehe, breite/2, hoehe);
    }
}