import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.*;
/**
 * Der Bauernhof definiert das zu Hause des Bauern
 * Die Stalltr und die Haustr knnen sich  ffnen
 * Diese Felder sind auch betretbar.
 * 
 * @author T. Schaller 
 * @version 04.10.2021
 */
public class Bauernhof extends Gegenstand
{
    public Bauernhof() {
        super("Bauernhof", false, false, -1);
    }

    public void addedToWorld(World w) {
        super.addedToWorld(w);
        ((Bauernhofprojekt) w).addAktion(()->tuerenoeffnen());
    }   

    public void tuerenoeffnen() {
        List<Figur> innen = getObjectsAtOffset(-3, 2, Figur.class);
        innen.addAll(getObjectsAtOffset(2,2,Figur.class));
        for(Figur f : innen) {
            if((f.getX() == getX()-3 && f.getY() == getY()+2) ||
            (f.getX() == getX()+2 && f.getY() == getY()+2))
                getWorld().removeObject(f);
        }

        List<Figur> scheune = getObjectsAtOffset(-3, 3, Figur.class);
        List<Figur> haupthaus = getObjectsAtOffset(2,2,Figur.class);
        haupthaus.addAll(getObjectsAtOffset(2,3,Figur.class));

        if(haupthaus.size()>0) {
            setzeBild(2);
        } else {
            if(scheune.size()>0) {
                setzeBild(1);
            } else {
                setzeBild(0);
            }
        }
    }

    public boolean istBetretbar(int x, int y) {
        if(x-getX() == -3 && y-getY()==2) return true;
        if(x-getX() == 2 && y-getY()==2) return true;
        return false;
    }
}

